#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <unistd.h>

#include "lokkit.h"


static int ports[64];

static int Service(char *name, int port, char *data, int *pos, int *dir)
{
	int s=socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(s!=-1)
	{
		struct sockaddr_in sin;
		sin.sin_port = htons(port);
		sin.sin_addr.s_addr = htonl(0x7F000001);
		sin.sin_family = AF_INET;
		
		fcntl(s, F_SETFL, FNDELAY);
		
		if(connect(s, (struct sockaddr *)&sin, sizeof(sin))==-1)
		{
			if(errno==EINPROGRESS)
			{
				fd_set fds;
				struct timeval tv;
				FD_ZERO(&fds);
				FD_SET(s,&fds);
				tv.tv_sec=2;
				tv.tv_usec=0;
				if(select(s+1, &fds, NULL, NULL, &tv)<1)
				{
					close(s);
					*pos+=*dir;
					return 0;
				}
			}
		}
		close(s);
	}
	if(Wizard(name, data, "   Yes   ", "   No    ", NULL, pos, dir)==0)
	{
		ports[*pos-4]=port;
		return 0;
	}
	return 1;
}

static int has_device(char *name)
{
	FILE *f=fopen("/proc/net/dev", "r");
	char buf[512];
	int l=strlen(name);
	char *bp;
	
	while(fgets(buf,512,f)!=NULL)
	{
		bp=buf;
		while(*bp==' ')
			bp++;
		if(strncmp(bp, name, l)==0 && bp[l]==':')
		{
			fclose(f);
			return 1;
		}
	}
	fclose(f);
	return 0;
}

int main(int argc, char *argv[])
{
	char *p=argv[0];
	int step;
	int dir;
	
	int security=0, trustether=1, enable=0, trustether1=1;
	
	
	if(strrchr(p,'/'))
		p=strrchr(p,'/')+1;
		
	InitGUI();
		
	if(strcmp(p,"unlokkit")==0)
	{
		if(remove("/etc/sysconfig/firewall")==-1 && errno != ENOENT)
		{
			Wizard("An Error Has Occurred",
	"Lokkit was unable to write to the file\n"
	"/etc/sysconfig/firewall. This is normally caused by\n"
	"running Lokkit when you are not logged in as root.",
			 	NULL, NULL, NULL, &step, &dir);
			EndGUI();
			exit(1);
		}
		else
		{
			Wizard("Firewall removed",
	"Lokkit has removed the firewall configuration you had\n"
	"setup. Lockkit will now flush the firewall rules.",
			 	NULL, NULL, NULL, &step, &dir);
		
			EndGUI();
			flush_firewall();
			exit(0);
		}
	}
	
	
	step = 0;
	dir = 1;
	
	while(1)
	{	
		switch(step)
		{		
			case 0:

				security = Wizard("Basic Configuration",
						"Lokkit can set up either a low or high security\n"
						"configuration. A high security configuration blocks all\n"
						"incoming accesses but requires you use specific ftp\n"
						"configurations and blocks irc dcc. The lower security\n"
						"option blocks system services but is not so intrusive.",
						"High Security - more intrusive",
						"Low Security  - less intrusive",
						NULL, &step, &dir);
				break;		
		
			case 1:

				if(has_device("eth0"))
				{
					trustether = Wizard("Local Hosts",
						"You seem to have an ethernet attached to your machine.\n"
						"Shall I trusts the hosts that are connected via this card.\n"
						"If this connection is your link to the internet (eg cable\n"
						"modem) you should say no.",
						"   Yes   ",
						"   No    ",
						NULL, &step, &dir);
				}
				else
				{
					trustether = 0;
					step+=dir;
					continue;
				}
				break;
		
			case 2:
	
				if(has_device("eth1"))
				{
					trustether1 = Wizard("Local Hosts",
						"You seem to have a second ethernet attached to your machine.\n"
						"Shall I trusts the hosts that are connected via this card.\n"
						"If this connection is your link to the internet (eg cable\n"
						"modem) you should say no.",
						"   Yes   ",
						"   No    ",
						NULL, &step, &dir);
				}
				else
				{
					trustether1 = 0;
					step+=dir;
					continue;
				}
		
	
			case 3:
				enable = Wizard("Services",
					"You can enable access to some of the incoming services\n"
					"on your machine. Before doing so you should check you\n"
					"are up to date with any errata from your Linux vendor.\n"
					"Do you wish to select services to enable.\n",
					"   Yes   ",
					"   No    ",
					NULL, &step, &dir);
				break;

			case 4:
							
				if(enable==0)
				{
					Service("Web Server", 80,
						"This allows people to access and view the web server on\n"
						"your computer. You do not need to enable this to use the\n"
						"web server directly from the machine itself for things\n"
						"like developing pages.", &step, &dir);	
				}
				else
				{
					step+=dir;
					continue;
				}
				break;
				
			case 5:
				if(enable==0)
				{
					Service("Incoming Mail", 25,
						"Allow incoming SMTP mail delivery. You do not need to enable\n"
						"this if you collect your mail from your ISP's server by POP3\n"
						"or IMAP, or if you use a tool such as fetchmail.",
						&step, &dir);
				}
				else
				{
					step+=dir;
					continue;
				}
				break;
				
			case 6:
				if(enable==0)
				{	
					Service("Secure Shell", 22,
						"Allow incoming secure shell access. This is an encrypted\n"
						"way to talk to your computer over the internet. You may\n"
						"also wish to read the ssh documentation and set up a list\n"
						"of hosts permitted to connect.",
						&step, &dir);
				}
				else
				{
					step+=dir;
					continue;
				}
				break;
			case 7:
				if(enable==0)
				{	
					Service("Telnet", 23, 
						"Allow incoming telnet accesss. This allows access to the\n"
						"command line shell of the machine from outside, if you\n"
						"have a username and password. It is not encrypted and can\n"
						"therefore be spied upon. If possible avoid enabling this.",
						&step, &dir);
				}
				else
				{
					step+=dir;
					continue;
				}
				
				break;
			
			case 8:
				goto done;
		}
	}

done:

	if(write_firewall(security, trustether, trustether1, ports)==-1)
	{
		Wizard("An Error Has Occurred",
	"Lokkit was unable to write to the file\n"
	"/etc/sysconfig/firewall. This is normally caused by\n"
	"running Lokkit when you are not logged in as root.",
	 	NULL, NULL, NULL, &step, &dir);
		EndGUI();
	}
	else
	{
		Wizard("Lokkit",
	"Lokkit has updated the firewall rule table for your machine\n"
	"and will now load the firewall entries for you.",
	 	NULL, NULL, NULL, &step, &dir);
		EndGUI();
	 	system("/bin/sh /etc/sysconfig/firewall");
	}
	return 0;
}
